"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function intersection(by, ...arrays) {
    const isFn = typeof by === 'function';
    const _by = isFn ? by : undefined;
    const _arrays = isFn ? arrays : [by, ...arrays];
    const _arrayMap = (_arrays[0] || []).reduce((all, value) => {
        const key = isFn ? _by(value) : value;
        all[key] = value;
        return all;
    }, {});
    const mapArray = _arrays.map(array => {
        const _map = array.reduce((all, value) => {
            const key = isFn ? _by(value) : value;
            all[key] = 1;
            return all;
        }, {});
        return _map;
    });
    return Object
        .keys(_arrayMap).filter(key => {
        return mapArray.every(map => map[key] === 1);
    })
        .map(key => _arrayMap[key]);
}
exports.intersection = intersection;
//# sourceMappingURL=intersection.js.map